/*
 * Created on 18.09.2014
 */
package test;

import org.jboss.logging.Logger;
import org.jboss.msc.service.Service;
import org.jboss.msc.service.ServiceName;
import org.jboss.msc.service.StartContext;
import org.jboss.msc.service.StartException;
import org.jboss.msc.service.StopContext;

public class MySingletonService implements Service<MyServiceEnvironment>
{
	private static final Logger logger = Logger.getLogger(MySingletonService.class);

	public static final ServiceName SERVICE_NAME = ServiceName.JBOSS.append("test", "singleton", "service",
		"MySingletonService", "default");

	private MyServiceEnvironment myServiceEnv;

	public MySingletonService(MyServiceEnvironment myServiceEnv)
	{
		this.myServiceEnv = myServiceEnv;
	}

	public void setName(String name)
	{
		myServiceEnv.setName(name);
	}

	public String getName()
	{
		return myServiceEnv.getName();
	}

	public void greet()
	{
		System.out.println("Hi " + myServiceEnv.getName());
	}

	public MyServiceEnvironment getValue() throws IllegalStateException, IllegalArgumentException
	{
		return new MyServiceEnvironment(myServiceEnv.getName());
	}

	public void start(StartContext context) throws StartException
	{
		logger.info("start MySingletonService");
	}

	public void stop(StopContext context)
	{
		logger.info("stop MySingletonService");
	}
}
